
is.list.element <- function(inp.list, el.name) {
	el.set <- names(inp.list)
	return(any(is.element(el.set, el.name)))
}


UpdateStatsList <- function(parameter, value) {
	if(is.list.element(stats.list, parameter) == FALSE)
		stop('Arguement is not an element in stats.list')
	cur.values <- unlist(stats.list[[parameter]])
	upt.values <- c(cur.values, value)
	stats.list[[parameter]] <<- list(upt.values)
}

GetSummableOptType <- function(step.num) {
	ret.list <- list()
	ret.list$descstat <- ifelse(is.descstat.op(step.num), 1, 0)
	ret.list$eval <- ifelse(is.eval.op(step.num), 1, 0)
	ret.list$expl <- ifelse(is.expl.op(step.num), 1, 0)
	return(as.data.frame(ret.list))

}

UpdateBatchInformation <- function(step.num.list) {	
	stats.list[['batch.ops']][[stats.list$cnt]] <<- list()
	stats.list[['batch.ops']][[stats.list$cnt]] <<- step.num.list
	stats.list$cnt <<- stats.list$cnt + 1
}

UpdateStatsOperatorClass <- function(step.num.list) {
	df <- list()
	df$descstat <- 0
	df$eval <- 0
	df$expl <- 0
	df <- as.data.frame(df)
	for(step.num in step.num.list) {
		sub.df <- GetSummableOptType(step.num)
		df <- df + sub.df
	}
	UpdateStatsList('num.desc.stats', df$descstat)
	UpdateStatsList('num.eval', df$eval)
	UpdateStatsList('num.expl', df$expl)
	UpdateBatchInformation(step.num.list)
}
InitStats <- function() {
	stats.list <<- list()
	stats.list$mat.time <<- list()
	stats.list$batch.idx <<- list()
	stats.list$exe.time <<- list()
	stats.list$init.time <<- list()
	stats.list$retrieve.result <<- list()
	stats.list$num.desc.stats <<- list()
	stats.list$num.eval <<- list()
	stats.list$num.expl <<- list()
	stats.list$batch.ops <<- list()
	stats.list$cnt <<- 1
}
