source('init.R')
source('manual.R')
source('descstats.R')
source('mdbutilities.R')
source('datalayer_delegator.R')
source('datalayer_oracledb.R')
source('skel_manual.R')
source('exe_manual.R')
source('skel_descstats.R')
source('skel_exploratory.R')
source('exe_descstats_corr.R')
source('exe_descstats_coef.R')
source('exe_descstats_eval.R')
source('exe_descstats_expl.R')
source('exe_utilities.R')
source('exploratory.R')
source('optimizer.R')
source('exe_stats.R')
source('batch.R')
source('src_prov.R')

source('plots.R')





InitStats()
rangefeatlist <- list()
cnt.apply <- 0
exe.apply <- 0
GetNPlotSubDF <- function(stats.list, index, scale) {
	# input:  list
	# output
	# batch.num op.type time
	# op.type : 'mat.time', 'exe.time', 'retrieve.result', 'init.time'
	

	batch.num <- c()
	op.type <- c()
	time.taken <- c()

	idx <- 1
	batch.num[idx] <- unlist(stats.list[['batch.idx']])[index]
	op.type[idx] <- 'init.time'
	time.taken[idx] <- unlist(stats.list[['init.time']])[index] 

	idx <- 2
	batch.num[idx] <- unlist(stats.list[['batch.idx']])[index]
	op.type[idx] <- 'exe.time'
	time.taken[idx] <- unlist(stats.list[['exe.time']])[index]

	
	idx <- 3
	batch.num[idx] <- unlist(stats.list[['batch.idx']])[index]
	op.type[idx] <- 'mat.time'
	time.taken[idx] <- unlist(stats.list[['mat.time']])[index]
	
	idx <- 4
	batch.num[idx] <- unlist(stats.list[['batch.idx']])[index]
	op.type[idx] <- 'parse.result'
	time.taken[idx] <- unlist(stats.list[['retrieve.result']])[index]

	time.taken <- time.taken * scale
	df <- data.frame(batch.num, op.type, time.taken)
	names(df) <- c('Batch', 'OpType', 'Time.Taken')
	return(df)
}
GetNPlotOpTypeFreqsSubDF <- function(stats.list, index) {
	
	batch.num <- c()
	op.class <- c()
	num.ops <- c()

	idx <- 1
	batch.num[idx] <- unlist(stats.list[['batch.idx']])[index]
	op.class[idx] <- 'desc.stat'
	num.ops[idx] <- unlist(stats.list[['num.desc.stats']])[index]
	
	idx <- 2
	batch.num[idx] <- unlist(stats.list[['batch.idx']])[index]
	op.class[idx] <- 'evaluate'
	num.ops[idx] <- unlist(stats.list[['num.eval']])[index]

	idx <- 3
	batch.num[idx] <- unlist(stats.list[['batch.idx']])[index]
	op.class[idx] <- 'explore'
	num.ops[idx] <- unlist(stats.list[['num.expl']])[index]
	
	df <- data.frame(batch.num, op.class, num.ops)
	names(df) <- c('Batch', 'OpClass', 'NumOperations')
	return(df)
}
	

UpdateBatchIndices <- function(inp.batch.list) {
	inp.batch.list <- unlist(inp.batch.list)
	len <- length(inp.batch.list)
	return(list(seq(1, len, 1)))
	
}

GetNPlotDF <- function(stats.list, scale = 1) {
	stats.list[['batch.idx']] <- UpdateBatchIndices(stats.list[['batch.idx']])
	num.batches <- length(unlist(stats.list[['batch.idx']]))
	df <- data.frame()
	if(num.batches == 0)
		return(df)
	for(idx in seq(1, num.batches, 1)) {
		sub.df <- GetNPlotSubDF(stats.list, idx, scale)
		df <- rbind(df, sub.df)
	}
	return(df)
}


GetNPlotOpTypeFreqsDF <- function(stats.list) {
	stats.list[['batch.idx']] <- UpdateBatchIndices(stats.list[['batch.idx']])
	num.batches <- length(unlist(stats.list[['batch.idx']]))
	df <- data.frame()
	for(idx in seq(1, num.batches, 1)) {
		sub.df <- GetNPlotOpTypeFreqsSubDF(stats.list, idx)
		df <- rbind(df, sub.df)
	}	
	return(df)
} 




namel<-function (vec){
		tmp<-as.list(vec)
		names(tmp)<-as.character(unlist(vec))
		tmp
	}

QueryStringForMaterialization <- function(from.dataset.name, rangefeatlist, output.dataset.name) {
	len.list <- length(rangefeatlist)
	out.str <- ""
	print(rangefeatlist)
	if(len.list > 0) {
	out.str <- paste("CREATE TABLE ", output.dataset.name, "  as SELECT * FROM ", from.dataset.name, " WHERE ", sep = "")
	 for(i in 1:len.list) {
		feat.name <- rangefeatlist[[i]]$feat.name
		min.val <- rangefeatlist[[i]]$min.val
		max.val <- rangefeatlist[[i]]$max.val
		out.str <- paste(out.str, feat.name," >= ",  min.val, "AND", feat.name, " <= ", max.val, sep=" ")
		if(i != len.list)
			out.str <- paste(out.str, " AND ")
	 }
 	}
	return(out.str)
	
}

