source('init.R')
source('manual.R')
source('descstats.R')
source('mdbutilities.R')
source('datalayer_delegator.R')
source('datalayer_oracledb.R')
source('skel_manual.R')
source('exe_manual.R')
source('skel_descstats.R')
source('skel_exploratory.R')
source('exe_descstats_corr.R')
source('exe_descstats_coef.R')
source('exe_descstats_eval.R')
source('exe_descstats_expl.R')
source('exe_utilities.R')
source('exploratory.R')
source('optimizer.R')
source('exe_stats.R')


BatchMode <- function(src.file) {
	#stats
	stats.list <<- list()
	stats.list$mat.time <<- list()
	stats.list$batch.idx <<- list()
	stats.list$exe.time <<- list()
	stats.list$init.time <<- list()
	stats.list$retrieve.result <<- list()
	#stats

source(src.file)
dataset.id.list <- unique(mdb$Program$dataset.id)
for(dataset.id in dataset.id.list) {

	while(TRUE) {
		# Optimizer
		node.list <- GenNodeList(dataset.id)
		
		node.list <- RunDataAgnosticOperation(node.list, dataset.id)
		updated.nodelist <- UpdateLevels(node.list, dataset.id)
		batch.list <- CreateBatches(updated.nodelist)
		len.batch.list <- length(batch.list)
	
		if(len.batch.list > 0) {
	 
			# There is atleast one batch
		 	feat.set.list <- GetFeatureSetForBatchList(batch.list)
			if(is.matopt() == TRUE) {
				rep.list <- GetRepetitionList(feat.set.list)
				int.tables <- GetMatInterimTables(rep.list, dataset.id)
				dir.table <- int.tables$dir.table
				cost.table <- int.tables$cost.table
				mat.from <- int.tables$mat.from

				batch.tables.map <- GetBatchTablesMap(rep.list, cost.table, dir.table, feat.set.list, dataset.id)
				
				
				
			} else {
				batch.tables.map <- DefaultBatchTablesMap(len.batch.list, dataset.id)
			
			}
			# Executor 
			RunDataAwareOperation(batch.list, node.list, batch.tables.map, dataset.id)
		} 
		else {
			break;
		}
	}

	
}

}
