
source('global.R')
source('plotCorrelation.R')
library(ggplot2)
source('plots.R')
library(shiny)
library(shinyIncubator)
#library(shinyExt)


GetDatasetnames()

id <- GetDatasetId("TelecomVersion2")
print(GetFeatureNames(GetFeatureIndices(id), id))

fs1 <- AssignFeatureSet(c("DATAVOLUME", "NUMMMSOUT", "NUMVASOUT", "NUMCALLSFIXEDOUT", "DURATIONFIXEDINC", "NUMSMSINTEROUT", "NUMSMSCMPINC", "NUMSMSVASINC"), dataset.id = id)
fm1 <- CorrelationX(fs1, dataset.id = id)

PlotCorrelation(fm1, dataset.id = id)

fs2 <- AssignFeatureSet(c("NUMCALLSFIXEDOUT"), dataset.id = id)
fs3 <- DelFeatureSet(fs1, fs2, dataset.id = id)
fm2 <- CoeffLearner(fs3, "igd", num.iters = 2, dataset.id = id)
fs4 <- BestK(fm2, 6, dataset.id = id)

res <- bGetNumTimesAccessed("TelecomVersion2")
print(res)
fm6 <- Evaluate(fs4, "cg", "cv", num.iters=2, num.folds=3, dataset.id=id) # change to 5 folds
res <- bGetNumTimesAccessed("TelecomVersion2")
print(res)

fs5 <- StepDel(fs4, "cg", "aic", dataset.id = id)
print(fs5)
SaveSession("ColumbusProgram1", dataset.id = id)

# plot the dag
g <- GetProgramDag("ColumbusProgram1", dataset.id = id)

renderGraph(g)

# let us do a step delete on the fs1 featureset.
fs6 <- StepDel(fs1, "cg", "aic", dataset.id = id)
print(fs6)
g <- GetProgramDag("ColumbusProgram1", dataset.id = id)

renderGraph(g)





new.dataset.id <- GetDatasetId("TelecomVersion1")
#ViewProgram("ColumbusProgram1", dataset.id = new.dataset.id)
ExecuteProgram("ColumbusProgram1", dataset.id = new.dataset.id) # BatchMode execution
g <- GetBatchProgramDag("ColumbusProgram1", dataset.id = new.dataset.id)

renderGraph(g)



# Plot results

PlotResults(stats.list)


# Plot Dag (googleVis) # pdf
# Operations to be allowed, dataset features !!!
