require(rCharts)
shinyUI(
	pageWithSidebar(
	headerPanel("Columbus"),
		sidebarPanel(
			# ---- INPUT ----- 
			# Dataset
			wellPanel(
				uiOutput("datasets")
			),
			wellPanel(
				radioButtons("optype", "Operation Type :",
						c("Create Feature set" = "create",
						  "Execute Operation" = "execute",
						  "View Program" = "viewpgm",
						  "None" = "none"
						  ), selected = "None"
				)
			),
			conditionalPanel(condition = "input.optype == 'create'",
			 wellPanel(
				uiOutput("features"),
				uiOutput("featuresetname"),
				actionButton('createfs', 'Create') 
			 )
			),
			conditionalPanel(condition = "input.optype == 'viewpgm'",
			 wellPanel(
				uiOutput('savepgmtextinput'),
				actionButton('saveprogram', 'Save Program')
				# fix this.	
			 )
			),
			conditionalPanel(condition = "input.optype == 'execute'",
			 wellPanel(
			 	radioButtons("opclass", "Class :",
						c( "Descriptive Statistics" = "descstat",
						  "Explore" = "explore",
						  "Evaluate" = "evaluate",
						  "None" = "none"), selected = "None"
				)
			 )


			),
			 conditionalPanel(condition = "input.opclass == 'descstat'",
			    wellPanel(
				radioButtons("descstat_type", "Descriptive Stat type", 
						c("Mutual Correlation" = "corrx",
						  "Correlation with target" = "corry",
						  "Learn Coefficients" = "coefflearn",
						  "None" = "none"
						  ), selected = "None"
				)
			    ),
			    conditionalPanel(condition = "input.descstat_type == 'corrx'",
				wellPanel(
					uiOutput("availfeatsetnames"),
					actionButton('viewfs', 'View'),
					actionButton('execorrx', 'Execute')
				) 	
			    ),	
			    conditionalPanel(condition = "input.descstat_type == 'corry'",
				wellPanel(
					uiOutput("availfeatsetnames_corry"),
					actionButton("viewfscorry", 'View'),
					actionButton('execorry', 'Execute')
				)
			    ),
			    conditionalPanel(condition = "input.descstat_type == 'coefflearn'",
				wellPanel(
					uiOutput("availfeatsetnames_coefflearn"),
					actionButton("viewfscoefflearn", 'View'),
					radioButtons("coefflearn_type", "Coeff Learn Type :",
						c("IGD" = "igd", "CG" = "cg", "None" = "none"),
						selected = "None"
					)
				),
			 	 conditionalPanel(condition = "input.coefflearn_type == 'igd'",
				  wellPanel(
					numericInput("igd_numiters", "Num Iters:", value = 2),
					numericInput("igd_initwt", "Init Weight:", value = 0.1),
					numericInput("igd_learnrate", "Learning rate:", 0.1),
					actionButton('execoefflearnigd', 'Execute')
				  )
				 ),
				 conditionalPanel(condition = "input.coefflearn_type == 'cg'",

				  wellPanel(
					numericInput("cg_numiters", "Num Iters:", value = 5),
					actionButton('execoefflearncg', 'Execute')
				  )
		    		 )
			    ) # coeff learn end

			 ), # desc stat end
			 conditionalPanel(condition = "input.opclass == 'evaluate'",
			    wellPanel(
				radioButtons("eval_type", "Evaluation type", 
						c("Cross validation" = "eval_cv",
						  "Akaike Information Criterian" = "eval_aic",
						  "None" = "none"
						  ), selected = "None"
				)
			    ),
			    conditionalPanel(condition = "input.eval_type == 'eval_cv'",
				wellPanel(
					uiOutput("availfeatsetnames_eval_cv"),
					uiOutput("eval_cv_numfoldstext"),
					actionButton("viewfsevalcv", 'View'),
					radioButtons("eval_cv_coefflearn_type", "Coeff Learn Type :",
						c("IGD" = "eval_cv_igd", "CG" = "eval_cv_cg", "None"
= "none"),
						selected = "None"
					)
				),
				conditionalPanel(condition = "input.eval_cv_coefflearn_type == 'eval_cv_igd'",
				  wellPanel(
					numericInput("eval_cv_igd_numiters", "Num Iters:", value = 2),
					numericInput("eval_cv_igd_initwt", "Init Weight:", value = 0.1),
					numericInput("eval_cv_igd_learnrate", "Learning rate:", 0.1),
					actionButton('exeevalcvigd', 'Execute'),
					actionButton('viewplotscvigd', 'View Plots')
					#radioButtons("runtime_cv_igd", "Show Runtime :",
					#	c("Yes" = "Yes", "No" = "No"),
					#	selected = "No"
					#)
				  )
				), # condn panel eval_cv_igd_coefflearn_type
				conditionalPanel(condition = "input.eval_cv_coefflearn_type == 'eval_cv_cg'",
				  wellPanel(
					numericInput("eval_cv_cg_numiters", "Num Iters:", value = 5),
					actionButton('exeevalcvcg', 'Execute'),
					actionButton('viewplotscvcg', 'View Plots')
				  )
		    		 ) # codn panel eval_cv_cg_coefflearn type
				
			         	
			    ), #eval cv condn end
			    conditionalPanel(condition = "input.eval_type == 'eval_aic'",
				wellPanel(
					uiOutput("availfeatsetnames_eval_aic"),
					actionButton("viewfsevalaic", 'View'),
					radioButtons("eval_aic_coefflearn_type", "Coeff Learn Type :",
						c("IGD" = "eval_aic_igd", "CG" = "eval_aic_cg",
"None" = "none"),
						selected = "None"
					)
				),
				conditionalPanel(condition = "input.eval_aic_coefflearn_type ==
'eval_aic_igd'",
				  wellPanel(
					numericInput("eval_aic_igd_numiters", "Num Iters:", value = 2),
					numericInput("eval_aic_igd_initwt", "Init Weight:", value = 0.1),
					numericInput("eval_aic_igd_learnrate", "Learning rate:", 0.1),
					actionButton('exeevalaicigd', 'Execute'),
					actionButton('viewplotsaicigd', 'View Plots')
				  )
				), # condn panel eval_aic_igd_coefflearn_type
				conditionalPanel(condition = "input.eval_aic_coefflearn_type ==
'eval_aic_cg'",
				  wellPanel(
					numericInput("eval_aic_cg_numiters", "Num Iters:", value = 5),
					actionButton('exeevalaiccg', 'Execute'),
					actionButton('viewplotsaiccg', 'View Plots')
				  )
		    		 ) # condn panel eval_aic_cg_coefflearn type
			         	
			    ) #eval aic condn end
			), # evaluate end
			conditionalPanel(condition = "input.opclass == 'explore'",
			    wellPanel(
				radioButtons("explore_type", "Explore type", 
						c("Step Add" = "step_add",
						  "Step Drop" = "step_drop",
						  "None" = "none"
						  ), selected = "None"
				)
			    ),
			    conditionalPanel(condition = "input.explore_type == 'step_add'",
			 	wellPanel(
					uiOutput("availfeatsetnames_stepadd_inp"),
					uiOutput("availfeatsetnames_stepadd_mask"),
					actionButton("viewfs_stepadd_inpset", "View Input"),
					actionButton("viewfs_stepadd_maskset", "View Mask"),
					br(),
					radioButtons("stepadd_eval_type", "Evaluation type",
						c("Cross validation" = "stepadd_eval_cv",
						  "Akaike Information Criterian" = "stepadd_eval_aic",
						  "None" = "none"
						  ), selected = "None"
					),
			    		conditionalPanel(condition = "input.stepadd_eval_type == 'stepadd_eval_cv'",
						wellPanel(
							uiOutput("stepadd_eval_cv_numfoldstext"),
							radioButtons("stepadd_eval_cv_coefflearn_type", "Coeff Learn Type :",
								c("IGD" = "stepadd_eval_cv_igd", "CG" = "stepadd_eval_cv_cg", "None" = "none"),		
								selected = "None"
							)
						),
						conditionalPanel(condition = "input.stepadd_eval_cv_coefflearn_type == 'stepadd_eval_cv_igd'",
						  wellPanel(
							numericInput("stepadd_eval_cv_igd_numiters", "Num Iters:", value = 2),
							numericInput("stepadd_eval_cv_igd_initwt", "Init Weight:", value = 0.1),
							numericInput("stepadd_eval_cv_igd_learnrate", "Learning rate:", 0.1),
							actionButton('exestepaddevalcvigd', 'Execute'),
							actionButton('viewplotsstepaddcvigd', 'View Plots')
			  	  		  )
						), # condn panel stepadd_eval_cv_igd_coefflearn
					        conditionalPanel(condition = "input.stepadd_eval_cv_coefflearn_type == 'stepadd_eval_cv_cg'",
						  wellPanel(
							numericInput("stepadd_eval_cv_cg_numiters", "Num Iters:", value = 5),
							actionButton('exestepaddevalcvcg', 'Execute'),
							actionButton('viewplotsstepaddcvcg', 'View Plots')
						  )
		    		 		) # codn panel stepadd_eval_cv_cg_coefflearn type
						
					), # conditional panel for stepadd eval cv
						
					
			    		conditionalPanel(condition = "input.stepadd_eval_type == 'stepadd_eval_aic'",
						wellPanel(
							radioButtons("stepadd_eval_aic_coefflearn_type", "Coeff Learn Type :",
								c("IGD" = "stepadd_eval_aic_igd", "CG" = "stepadd_eval_aic_cg", "None" = "none"),		
								selected = "None"
							)
						),
						conditionalPanel(condition = "input.stepadd_eval_aic_coefflearn_type == 'stepadd_eval_aic_igd'",
						  wellPanel(
							numericInput("stepadd_eval_aic_igd_numiters", "Num Iters:", value = 2),
							numericInput("stepadd_eval_aic_igd_initwt", "Init Weight:", value = 0.1),
							numericInput("stepadd_eval_aic_igd_learnrate", "Learning rate:", 0.1),
							actionButton('exestepaddevalaicigd', 'Execute'),
							actionButton('viewplotsstepaddaicigd', 'View Plots')
				  		  )
						), # condn panel stepadd_eval_aic_igd_coefflearn_type
						conditionalPanel(condition = "input.stepadd_eval_aic_coefflearn_type == 'stepadd_eval_aic_cg'",
				  		  wellPanel(
							numericInput("stepadd_eval_aic_cg_numiters", "Num Iters:", value = 5),
							actionButton('exestepaddevalaiccg', 'Execute'),
							actionButton('viewplotsstepaddaiccg', 'View Plots')
				  		  )
		    		 		) # condn panel stepadd_eval_aic_cg_coefflearn type
			         	
			    		) #step addeval aic condn end
					
				), # step add well panel end
				wellPanel(
					uiOutput("stepadd_newfeaturesetname")
				)
			    ), # step add end
			    conditionalPanel(condition = "input.explore_type == 'step_drop'",
			 	wellPanel(
					uiOutput("availfeatsetnames_stepdrop_inp"),
					actionButton("viewfs_stepdrop_inpset", "View Input"),
					br(),
					radioButtons("stepdrop_eval_type", "Evaluation type",
						c("Cross validation" = "stepdrop_eval_cv",
						  "Akaike Information Criterian" = "stepdrop_eval_aic",
						  "None" = "none"
						  ), selected = "None"
					),
			    		conditionalPanel(condition = "input.stepdrop_eval_type == 'stepdrop_eval_cv'",
						wellPanel(
							uiOutput("stepdrop_eval_cv_numfoldstext"),
							radioButtons("stepdrop_eval_cv_coefflearn_type", "Coeff Learn Type :",
								c("IGD" = "stepdrop_eval_cv_igd", "CG" = "stepdrop_eval_cv_cg", "None" = "none"),		
								selected = "None"
							)
						),
						conditionalPanel(condition = "input.stepdrop_eval_cv_coefflearn_type == 'stepdrop_eval_cv_igd'",
						  wellPanel(
							numericInput("stepdrop_eval_cv_igd_numiters", "Num Iters:", value = 2),
							numericInput("stepdrop_eval_cv_igd_initwt", "Init Weight:", value = 0.1),
							numericInput("stepdrop_eval_cv_igd_learnrate", "Learning rate:", 0.1),
							actionButton('exestepdropevalcvigd', 'Execute'),
							actionButton('viewplotsstepdropcvigd', 'View Plots')
			  	  		  )
						), # condn panel stepdrop_eval_cv_igd_coefflearn
					        conditionalPanel(condition = "input.stepdrop_eval_cv_coefflearn_type == 'stepdrop_eval_cv_cg'",
						  wellPanel(
							numericInput("stepdrop_eval_cv_cg_numiters", "Num Iters:", value = 5),
							actionButton('exestepdropevalcvcg', 'Execute'),
							actionButton('viewplotsstepdropcvcg', 'View Plots')
						  )
		    		 		) # codn panel stepdrop_eval_cv_cg_coefflearn type
						
					), # conditional panel for stepdrop eval cv
						
					
			    		conditionalPanel(condition = "input.stepdrop_eval_type == 'stepdrop_eval_aic'",
						wellPanel(
							radioButtons("stepdrop_eval_aic_coefflearn_type", "Coeff Learn Type :",
								c("IGD" = "stepdrop_eval_aic_igd", "CG" = "stepdrop_eval_aic_cg", "None" = "none"),		
								selected = "None"
							)
						),
						conditionalPanel(condition = "input.stepdrop_eval_aic_coefflearn_type == 'stepdrop_eval_aic_igd'",
						  wellPanel(
							numericInput("stepdrop_eval_aic_igd_numiters", "Num Iters:", value = 2),
							numericInput("stepdrop_eval_aic_igd_initwt", "Init Weight:", value = 0.1),
							numericInput("stepdrop_eval_aic_igd_learnrate", "Learning rate:", 0.1),
							actionButton('exestepdropevalaicigd', 'Execute'),
							actionButton('viewplotsstepdropaicigd', 'View Plots')
				  		  )
						), # condn panel stepdrop_eval_aic_igd_coefflearn_type
						conditionalPanel(condition = "input.stepdrop_eval_aic_coefflearn_type == 'stepdrop_eval_aic_cg'",
				  		  wellPanel(
							numericInput("stepdrop_eval_aic_cg_numiters", "Num Iters:", value = 5),
							actionButton('exestepdropevalaiccg', 'Execute'),
							actionButton('viewplotsstepdropaiccg', 'View Plots')
				  		  )
		    		 		) # condn panel stepdrop_eval_aic_cg_coefflearn type
			         	
			    		) #step dropeval aic condn end
					
				), # step drop well panel end
				wellPanel(
					uiOutput("stepdrop_newfeaturesetname")
				)
			    ) # step drop
			
				
			) # explore end
			
			
   
		      ),# side bar panel end
		
			# ---- OUTPUT -----
		mainPanel(
	        	conditionalPanel(
			 condition = "input.optype == 'create'",
			 wellPanel(
				h4(textOutput("createfsmsgout"))
			 )
			),
	        	conditionalPanel(
			 condition = "input.optype == 'viewpgm'",
			 wellPanel(
				h4("Program Text"),
				h5(verbatimTextOutput("viewprogramtext")),
				h4('saveprograminformation')
			 )
			),
			conditionalPanel(
			 condition = "input.descstat_type == 'corrx'",
			 wellPanel(
				h4(textOutput("viewfeaturesets"))
			 ),
			 wellPanel(
				showOutput("corrxresult", "nvd3")
			 )
			),
			
			
			conditionalPanel(condition = "input.descstat_type == 'corry'",
			 wellPanel(
			 	h4(textOutput("viewfeaturesets_corry"))
			 ),
			 #uiOutput("viewfeaturesets_corry")
			 #h4(textOutput("Hi"))
			 wellPanel(
			 	h4("Correlation with target"),
			 	showOutput("corryresult", "morris")
			 )
			),
			
			conditionalPanel(condition = "input.descstat_type == 'coefflearn'",
			 wellPanel(
				h4(textOutput("viewfeaturesets_coefflearn"))
			 ),
			 wellPanel(
				h4("Coefficient values"),
				#h4("Coefficient values")

				conditionalPanel(condition = "input.coefflearn_type == 'igd'",
  				  #h4("Coefficient values_igs")
				  showOutput("coefflearnresult_igd", "morris")
				),
				conditionalPanel(condition = "input.coefflearn_type == 'cg'",
				  showOutput("coefflearnresult_cg", "morris")
				)
			)
		       ), # coeff learn output end
		       
		      conditionalPanel(condition = "input.eval_type == 'eval_cv'",
			wellPanel(
				h4(textOutput("viewfeaturesets_evalcv"))
				#h4("Eval cv")
			),
		      
			wellPanel(
				h4("Cross validation error"),
				conditionalPanel(condition = "input.eval_cv_coefflearn_type == 'eval_cv_igd'",
				  #showOutput("evalcvresult_igd", "morris")
				  h5(textOutput("evalcvresult_igd")),
				     #wellPanel(
				  uiOutput("text_coeffvalues_cv_igd"),
				  showOutput("evalcoeffresult_igd", "nvd3"),
				  uiOutput("text_runtime_cv_igd"),
				  showOutput("runtimechart_evalcv_igd", "nvd3")
				  #showOutput("runtimeresult_igd", "nvd3")
					#showOutput("runtimechart_evalcv_igd", "nvd3")
					   #conditionalPanel(condition = "input.runtime_cv_igd == 'Yes'",
					  #	uiOutput("text_runtime_cv_igd"),
					#	showOutput("runtimechart_evalcv_igd", "nvd3")
					 #  )
				     #)
				  #showOutput("runtimeresult_igd", "nvd3")
				),
				conditionalPanel(condition = "input.eval_cv_coefflearn_type == 'eval_cv_cg'",
				  h5(textOutput("evalcvresult_cg")),
				  showOutput("evalcoeffresult_cg", "nvd3"),
				  uiOutput("text_runtime_cv_cg"),
				  showOutput("runtimechart_evalcv_cg", "nvd3")
				)	
				
				#conditionalPanel(condition = "input.eval_type == 'eval_cv'",
				# conditionalPanel(condition = "input.eval_cv_coefflearn_type == 'eval_cv_igd'",
				#  showOutput("evalcvresult_igd", "morris"),
				#  #showOutput("plotscvigd", "morris")
				#  
				# ) 
				#)
				#conditionalPanel(condition = "input.eval_type == 'eval_aic'",
				#)
					
			)	
		     ), # eval cv ends
		      conditionalPanel(condition = "input.eval_type == 'eval_aic'",
			wellPanel(
				h4(textOutput("viewfeaturesets_evalaic"))
				#h4("Eval cv")
			),
			wellPanel(
				h4("AIC Score"),
				conditionalPanel(condition = "input.eval_aic_coefflearn_type == 'eval_aic_igd'",
				  h5(textOutput("evalaicresult_igd")),
				  uiOutput("text_coeffvalues_aic_igd"),
				  showOutput("evalcoeffresult_aic_igd", "nvd3"),
				  uiOutput("text_runtime_aic_igd"),
				  showOutput("runtimechart_evalaic_igd", "nvd3")
				),
				conditionalPanel(condition = "input.eval_aic_coefflearn_type ==
'eval_aic_cg'",
				  h5(textOutput("evalaicresult_cg")),
				  uiOutput("text_coeffvalues_aic_cg"),
				  showOutput("evalcoeffresult_aic_cg", "nvd3"),
				  uiOutput("text_runtime_aic_cg"),
				  showOutput("runtimechart_evalaic_cg", "nvd3")
				)
				
			)
			

		      
		     ), # eval aic ends
		     conditionalPanel(condition = "input.explore_type == 'step_add'",
			wellPanel(
				h4(textOutput("viewfeaturesets_stepadd_inpset")),
				h4(textOutput("viewfeaturesets_stepadd_maskset"))
				
				#h4("Eval cv")
			),
			wellPanel(
				h4("Step Add Result"),
				conditionalPanel(condition = "input.stepadd_eval_type == 'stepadd_eval_cv'",
				  conditionalPanel(condition = "input.stepadd_eval_cv_coefflearn_type == 'stepadd_eval_cv_igd'",
				      #h5(textOutput("stepadd_evalcvresult_igd")),
				      tableOutput("stepadd_evalcvresult_igd"),
				      uiOutput("text_runtime_stepadd_cv_igd"),
				      showOutput("runtimechart_stepadd_evalcv_igd", "nvd3")
				  ),
				  conditionalPanel(condition = "input.stepadd_eval_cv_coefflearn_type == 'stepadd_eval_cv_cg'",
				      #h5(textOutput("stepadd_evalcvresult_cg")),
				      tableOutput("stepadd_evalcvresult_cg"),
				      uiOutput("text_runtime_stepadd_cv_cg"),
				      showOutput("runtimechart_stepadd_evalcv_cg", "nvd3")
				  )
				),# conditional panel stepadd_eval_cv ends
				conditionalPanel(condition = "input.stepadd_eval_type == 'stepadd_eval_aic'",
				  conditionalPanel(condition = "input.stepadd_eval_aic_coefflearn_type == 'stepadd_eval_aic_igd'",
				      #h5(textOutput("stepadd_evalaicresult_igd")),
				      tableOutput("stepadd_evalaicresult_igd"),
				      uiOutput("text_runtime_stepadd_aic_igd"),
				      showOutput("runtimechart_stepadd_evalaic_igd", "nvd3")
				  ),
				  conditionalPanel(condition = "input.stepadd_eval_aic_coefflearn_type == 'stepadd_eval_aic_cg'",
				      #h5(textOutput("stepadd_evalaicresult_cg")),
				      tableOutput("stepadd_evalaicresult_cg"),
				      uiOutput("text_runtime_stepadd_aic_cg"),
				      showOutput("runtimechart_stepadd_evalaic_cg", "nvd3")
				  )
				)# conditional panel stepadd_eval_aic ends
			)

		     ), # stepadd ends
		     conditionalPanel(condition = "input.explore_type == 'step_drop'",
			wellPanel(
				h4(textOutput("viewfeaturesets_stepdrop_inpset"))
				
				#h4("Eval cv")
			),
			wellPanel(
				h4("Step Drop Result"),
				conditionalPanel(condition = "input.stepdrop_eval_type == 'stepdrop_eval_cv'",
				  conditionalPanel(condition = "input.stepdrop_eval_cv_coefflearn_type == 'stepdrop_eval_cv_igd'",
				      #h5(textOutput("stepdrop_evalcvresult_igd")),
				      tableOutput("stepdrop_evalcvresult_igd"),
				      uiOutput("text_runtime_stepdrop_cv_igd"),
				      showOutput("runtimechart_stepdrop_evalcv_igd", "nvd3")
				  ),
				  conditionalPanel(condition = "input.stepdrop_eval_cv_coefflearn_type == 'stepdrop_eval_cv_cg'",
				      #h5(textOutput("stepdrop_evalcvresult_cg")),
				      tableOutput("stepdrop_evalcvresult_cg"),
				      uiOutput("text_runtime_stepdrop_cv_cg"),
				      showOutput("runtimechart_stepdrop_evalcv_cg", "nvd3")
				  )
				),# conditional panel stepdrop_eval_cv ends
				conditionalPanel(condition = "input.stepdrop_eval_type == 'stepdrop_eval_aic'",
				  conditionalPanel(condition = "input.stepdrop_eval_aic_coefflearn_type == 'stepdrop_eval_aic_igd'",
				      #h5(textOutput("stepdrop_evalaicresult_igd")),
				      tableOutput("stepdrop_evalaicresult_igd"),
				      uiOutput("text_runtime_stepdrop_aic_igd"),
				      showOutput("runtimechart_stepdrop_evalaic_igd", "nvd3")
				  ),
				  conditionalPanel(condition = "input.stepdrop_eval_aic_coefflearn_type == 'stepdrop_eval_aic_cg'",
				      #h5(textOutput("stepdrop_evalaicresult_cg")),
				      tableOutput("stepdrop_evalaicresult_cg"),
				      uiOutput("text_runtime_stepdrop_aic_cg"),
				      showOutput("runtimechart_stepdrop_evalaic_cg", "nvd3")
				  )
				)# conditional panel stepdrop_eval_aic ends
			)

		     ) # stepdrop ends
			
		) # main panel end
		
	) # main end
)
    
