#Copyright 2013 Pradap  and Arun Kumar and Christopher Re
#
#Licensed under the Apache License, Version 2.0 (the "License");
#you may not use this file except in compliance with the License.
#You may obtain a copy of the License at
#
#http://www.apache.org/licenses/LICENSE-2.0
#
#Unless required by applicable law or agreed to in writing, software
#distributed under the License is distributed on an "AS IS" BASIS,
#WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#See the License for the specific language governing permissions and
#limitations under the License.

BatchMode <- function(src.file) {
	#stats
	stats.list <<- list()
	stats.list$mat.time <<- list()
	stats.list$batch.idx <<- list()
	stats.list$exe.time <<- list()
	stats.list$init.time <<- list()
	stats.list$retrieve.result <<- list()
	stats.list$num.desc.stats <<- list()
	stats.list$num.eval <<- list()
	stats.list$num.expl <<- list()
	stats.list$batch.ops <<- list()
	stats.list$cnt <<- 1
	
	#stats

source(src.file)
dataset.id.list <- unique(mdb$Program$dataset.id)
for(dataset.id in dataset.id.list) {

	while(TRUE) {
		# Optimizer

		time.taken <- system.time(node.list <- GenNodeList(dataset.id), gcFirst = TRUE)
		printf("GenNodeList took %f seconds", time.taken[[3]])
		
		time.taken <- system.time(node.list <- RunDataAgnosticOperation(node.list,
dataset.id), gcFirst = TRUE)
		printf("RunDataAgnostic Operation took %f seconds", time.taken[[3]])
		
		time.taken <- system.time(updated.nodelist <- UpdateLevels(node.list, dataset.id),
gcFirst = TRUE)
		printf("UpdateLevels Operation took %f seconds", time.taken[[3]])

	
		time.taken <- system.time(batch.list <- CreateBatches(updated.nodelist), gcFirst =
TRUE)
		printf("Createbatches took %f seconds", time.taken[[3]])

		len.batch.list <- length(batch.list)
	
		if(len.batch.list > 0) {
	 
			# There is atleast one batch
		 	time.taken <- system.time(feat.set.list <-
GetFeatureSetForBatchList(batch.list), gcFirst = TRUE)
			printf("GetFeatureSetForBatch took %f seconds", time.taken[[3]])
			
			if(is.matopt() == TRUE) {
				time.taken <- system.time(rep.list <-
GetRepetitionList(feat.set.list), gcFirst = TRUE)
				printf("GetRepetition list took  %f secs", time.taken[[3]])
				
				time.taken <- system.time(int.tables <-
GetMatInterimTables(rep.list, dataset.id), gcFirst = TRUE)
				printf("GetMatInterimTables took %f secs", time.taken[[3]])
				dir.table <- int.tables$dir.table
				cost.table <- int.tables$cost.table
				mat.from <- int.tables$mat.from

				time.taken <- system.time(batch.tables.map <-
GetBatchTablesMap(rep.list, cost.table, dir.table, feat.set.list, dataset.id), gcFirst = TRUE)
				printf("GetBatchTablesMap took :%f secs", time.taken[[3]])
				
				
				
			} else {
				batch.tables.map <- DefaultBatchTablesMap(len.batch.list, dataset.id)
			
			}
			# Executor 
			time.taken <- system.time(RunDataAwareOperation(batch.list, node.list,
batch.tables.map, dataset.id), gcFirst = TRUE)
			printf("RunDataAwareOperation took %f secs", time.taken[[3]])
		} 
		else {
			break;
		}
	}

	
}

}
