
#Copyright 2013 Pradap  and Arun Kumar and Christopher Re
#
#Licensed under the Apache License, Version 2.0 (the "License");
#you may not use this file except in compliance with the License.
#You may obtain a copy of the License at
#
#http://www.apache.org/licenses/LICENSE-2.0
#
#Unless required by applicable law or agreed to in writing, software
#distributed under the License is distributed on an "AS IS" BASIS,
#WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#See the License for the specific language governing permissions and
#limitations under the License.
#
#
StoreEvalCgCoeff <- function(step.num, inp.feat.indices = NULL) {
	StoreCgCoeff(step.num, inp.feat.indices)
}
StoreEvalIgdCoeff <- function(step.num, inp.feat.indices = NULL) {
	StoreIgdCoeff(step.num, inp.feat.indices)
}

StoreEvalCvAiC <- function(step.num, is.aic, inp.feat.indices = NULL) {
	
	table.name <- "EVAL_CV_AIC"
	column.names <- FillAttrnames(table.name)

	feat.id <- GetInputSetId.1(step.num)
	set.val <- unlist(GetFeatureSet(feat.id))
	set.val.str <- paste(set.val, collapse=",")
	list.id <- GetOutputListId(step.num)
	values <- unlist(GetFeatureMapValues(list.id)[[1]])
	value.str <- paste0(values, collapse=",")

	if(is.aic == 0)
		res <- SetUpForEvalCvTest(step.num)
	else
		res <- SetUpForEvalAiCTest(step.num)

	coeff.val <- unlist(res$coeff.list)
	coeff.val.str <- paste(coeff.val, collapse=",")
	
	# Get the results.
	program.id <- GetProgramId()
	session.id <- GetSessionId()
	program.ctr <- GetProgramCtr(step.num)
	dataset.id <- GetDatasetIdFromStepNum(step.num)

	if(is.null(inp.feat.indices))
		feat.indices <- SingleQuoteWrap(set.val.str)
	else
		feat.indices <- SingleQuoteWrap(inp.feat.indices)

	coeff.str <- SingleQuoteWrap(coeff.val.str)
	feat.str <- SingleQuoteWrap(res$init.string)
	str.hash <- SingleQuoteWrap(digest(res$init.string))
	value <- SingleQuoteWrap(value.str)

	# fill the results
	val <- list()
	val[[1]] <- program.id
	val[[2]] <- session.id	
	val[[3]] <- step.num
	val[[4]] <- program.ctr
	val[[5]] <- is.aic
	val[[6]] <- dataset.id
	val[[7]] <- feat.indices
	val[[8]] <- coeff.str
	val[[9]] <- feat.str
	val[[10]] <- str.hash
	val[[11]] <- value

	bInsert(table.name, column.names, val)
	res <- bCount(table.name)
	return(res)

}
StoreEvalCv <- function(step.num, inp.feat.indices = NULL) {
	is.aic <- 0
	StoreEvalCvAiC(step.num, is.aic, inp.feat.indices)
}
StoreEvalAiC <- function(step.num, inp.feat.indices = NULL) {
	is.aic <- 1
	StoreEvalCvAiC(step.num, is.aic, inp.feat.indices)
}
