
#Copyright 2013 Pradap  and Arun Kumar and Christopher Re
#
#Licensed under the Apache License, Version 2.0 (the "License");
#you may not use this file except in compliance with the License.
#You may obtain a copy of the License at
#
#http://www.apache.org/licenses/LICENSE-2.0
#
#Unless required by applicable law or agreed to in writing, software
#distributed under the License is distributed on an "AS IS" BASIS,
#WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#See the License for the specific language governing permissions and
#limitations under the License.
#
#
StoreStepAddEvalCg <- function(step.num) {
	inp.feat.id <- GetInputSetId.1(step.num)
	mask.feat.id <- GetInputSetId.2(step.num)

	inp.set.val <- unlist(GetFeatureSet(inp.feat.id))
	mask.set.val <- unlist(GetFeatureSet(mask.feat.id))
	
	inp.set.val.str <- paste0(inp.set.val, collapse=",")
	mask.set.val.str <- paste0(mask.set.val, collapse=",")
	
	inp.feat.indices <- paste(inp.set.val.str, mask.set.val.str, sep="#")
	
	StoreEvalCgCoeff(step.num, inp.feat.indices)
}

StoreStepAddEvalIgd <- function(step.num) {
	inp.feat.id <- GetInputSetId.1(step.num)
	mask.feat.id <- GetInputSetId.2(step.num)

	inp.set.val <- unlist(GetFeatureSet(inp.feat.id))
	mask.set.val <- unlist(GetFeatureSet(mask.feat.id))
	
	inp.set.val.str <- paste0(inp.set.val, collapse=",")
	mask.set.val.str <- paste0(mask.set.val, collapse=",")
	
	inp.feat.indices <- paste(inp.set.val.str, mask.set.val.str, sep="#")
	print(inp.feat.indices)
	
	StoreEvalIgdCoeff(step.num, inp.feat.indices)
}
StoreStepAddEvalAiC <- function(step.num) {
	inp.feat.id <- GetInputSetId.1(step.num)
	mask.feat.id <- GetInputSetId.2(step.num)

	inp.set.val <- unlist(GetFeatureSet(inp.feat.id))
	mask.set.val <- unlist(GetFeatureSet(mask.feat.id))
	
	inp.set.val.str <- paste0(inp.set.val, collapse=",")
	mask.set.val.str <- paste0(mask.set.val, collapse=",")
	
	inp.feat.indices <- paste(inp.set.val.str, mask.set.val.str, sep="#")
	
	StoreEvalAiC(step.num, inp.feat.indices)
}

StoreStepAddEvalCv <- function(step.num) {
	inp.feat.id <- GetInputSetId.1(step.num)
	mask.feat.id <- GetInputSetId.2(step.num)

	inp.set.val <- unlist(GetFeatureSet(inp.feat.id))
	mask.set.val <- unlist(GetFeatureSet(mask.feat.id))
	
	inp.set.val.str <- paste0(inp.set.val, collapse=",")
	mask.set.val.str <- paste0(mask.set.val, collapse=",")
	
	inp.feat.indices <- paste(inp.set.val.str, mask.set.val.str, sep="#")
	
	StoreEvalCv(step.num, inp.feat.indices)
}

StoreStepDelEvalIgd <- function(step.num) {
	StoreEvalIgdCoeff(step.num)
}

StoreStepDelEvalCg <- function(step.num) {
	StoreEvalCgCoeff(step.num)
}

StoreStepdelEvalCv <- function(step.num) {
	StoreEvalCv(step.num)
}

StoreStepdelEvalAiC <- function(step.num) {
	StoreEvalAiC(step.num)
}


