
public class Correlation extends MyAggregate {
    // compute : sum(xi), sum(xi^2) xi*yi
    double[] sumVar;
    double[] sumSqVar;
    double[] prodVar;
    int[] varIndices;
    int[] prodIndices;
    public int initialize(String s) {
        //layout: corrindices#corrpairs
        String[] splitted = s.split("#");
        String[] varString = splitted[0].split(",");
        String[] prodString = splitted[1].split(",");
        varIndices = new int[varString.length];
        sumVar = new double[varString.length];
        sumSqVar = new double[varString.length];

        prodIndices = new int[prodString.length];
        int sz = (int)Math.ceil(prodString.length/2);
        prodVar = new double[sz];

        for(int i = 0; i < varString.length; i ++) {
           varIndices[i] = Integer.parseInt(varString[i]);
        }
        for(int i = 0; i < prodString.length; i ++ ) {
            prodIndices[i] = Integer.parseInt(prodString[i]);
        }
        return 1;
    }
    public int iterate() {
        for(int i = 0; i < varIndices.length; i ++) {
            sumVar[i] = sumVar[i] + MyTuple.xVal[varIndices[i]];
            sumSqVar[i]  = sumSqVar[i] + (MyTuple.xVal[varIndices[i]]* MyTuple.xVal[varIndices[i]]);
        }
        int k = 0;
        for(int i = 0; i < prodVar.length; i++) {
            prodVar[i] = prodVar[i] + MyTuple.xVal[prodIndices[k]]*MyTuple.xVal[prodIndices[k+1]];
            k += 2;
        }
        return 1;
    }
    public String result() {
        // sumvar#sumSqVar#prodVar
        StringBuilder sb = new StringBuilder();
        StringBuilder sTemp1 = new StringBuilder();
        StringBuilder sTemp2 = new StringBuilder();
	
	sb.append(MyTuple.recId).append("#");

        for(int i = 0; i < varIndices.length; i++) {
            sTemp1.append(sumVar[i]);
            sTemp2.append(sumSqVar[i]);
            if(i != varIndices.length-1){
                sTemp1.append(",");
                sTemp2.append(",");
            }
        }
        sb.append(sTemp1).append("#").append(sTemp2).append("#");
        for(int i = 0; i < prodVar.length; i ++) {
            sb.append(prodVar[i]);
            if(i != prodVar.length-1)
                sb.append(",");
        }
        return sb.toString();
    }
    public int terminate() {
        varIndices = null;
        prodIndices = null;
        sumVar = null;
        prodVar = null;
        sumSqVar = null;
        return 1;
    }

}
