import java.util.ArrayList;

public class MyCGTrain extends MyAggregate{
    private MyFeatureSubsetCG objFS[];
    private int numFolds;


    public int initialize(String s) {
        // should initialize feature subsets and the coef values.
        // schema params#fs1#fs2#fs3
        String []splitted = s.split("#");

	

	//////SimpleLogger.write(s);
        numFolds = Integer.parseInt(splitted[0]);
        objFS = new MyFeatureSubsetCG[splitted.length-1];
	//SimpleLogger.write("Splitted Length - 1 : " + splitted.length);

        for(int i = 1; i < splitted.length; i ++) {
            objFS[i-1]= new MyFeatureSubsetCG();
            objFS[i-1].initFeatureSubset(numFolds, splitted[i]); // hardcoding the number of folds to 1.

        }
	//SimpleLogger.write("Getting out from initialize-cg");
        return 1;
    }
    public int train(int foldNum) {
        for(int i = 0; i < objFS.length; i ++) {
            int numFeatures = objFS[i].featureIndices.length;
            double wx = 0.0;
            double ux = 0.0;
            for(int j = 0; j < numFeatures; j ++)
            {
              double x = MyTuple.xVal[objFS[i].featureIndices[j]];
              wx = wx + objFS[i].coefficients[foldNum][j] * x;
              ux = ux + objFS[i].uValues[foldNum][j] * x  ;
            }
            double s1 = 1/(1+Math.exp(wx));
            double s2 = 1/(1+Math.exp(-1*wx));
            double s3 = ux * ux;
            objFS[i].denomWTerm[foldNum] = objFS[i].denomWTerm[foldNum] + (s1*s2*s3);
            //objFS[i].denomWTerm[foldNum] = Math.random() * 20;
            double yVal = MyTuple.yVal;
            if(yVal > 0.5)
                yVal = +1;
            else
                yVal = -1;
            double sig = 1/ ( 1 + Math.exp(-1*yVal*wx));
            for(int j = 0; j < numFeatures; j ++)
            {
                double x = MyTuple.xVal[objFS[i].featureIndices[j]];
                objFS[i].gradientVector[foldNum][j] += sig*yVal*x;
                //objFS[i].gradientVector[foldNum][j] += Math.random();
            }
        } // end of feature sets.
        return 1;
    }

    public int iterate() {
        if(numFolds == 1) {
            train(0);
        }
        else {
            for(int i = 0; i < numFolds; i ++) {
                if( ((MyTuple.recId % numFolds) + 1) != (i + 1)) {
                    train(i);
                }
            }
        }
        return 1;
    }

    public String result() {
        StringBuilder sb = new StringBuilder();
        String res;
        // layout : fs1 # fs2 # fs3
        //        : fs1 = featureSetIndices $ fold1 ~ fold2 ~ fold3 ~ ... ~ foldk
        //        : fold1 = coefficient values
        for(int i = 0; i < objFS.length; i ++)
        {
            res = objFS[i].getCGResult();
            sb.append(res);
            if(i != objFS.length - 1)
                sb.append("#");
        }
        return sb.toString();



    }
    public int terminate() {
        objFS = null;
        return 1;
    }



}
