/**
 * Created with IntelliJ IDEA.
 * User: Vamshika
 * Date: 4/20/13
 * Time: 8:33 PM
 * To change this template use File | Settings | File Templates.
 */
public class MyFeatureSubsetLRCV extends MyFeatureSubset
{
    public double[][] coefficients; // two dimensional because, this can be used for k-fold cv. For each feature set
    public int numFolds;
    public double[] numSuccess;
    public double[] numFailures;
    public double[] numObservations;

    public int initFeatureSubset(int numFolds, String inpString)
    {
        // inpString = feature set indices$fold1 ~ fold2 ~ fold3 ~ .. foldn
        // fold1 = coefval1 , coefval2 , coefval3.. ,coefvaln


        String[] splitted = inpString.split("\\$");


        this.numFolds = numFolds;
        numSuccess = new double[numFolds];
        numFailures =  new double[numFolds];
        numObservations = new double[numFolds];


        //splitted[1] will contain the feature set indices
        String[] sFeatureSetIndices = splitted[0].split(",");
        featureIndices = new int[sFeatureSetIndices.length];
        for(int i = 0; i < sFeatureSetIndices.length; i ++)
        {
            this.featureIndices[i] = Integer.parseInt(sFeatureSetIndices[i]);
        }

        String[] sFoldsAcrossCoefs = splitted[1].split("~");
        coefficients = new double[numFolds][featureIndices.length];
        for(int i = 0; i < numFolds; i ++)
        {
            String[] sCoefVals = sFoldsAcrossCoefs[i].split(",");
            for(int j = 0; j < sCoefVals.length; j ++ )
            {
                coefficients[i][j] = Double.parseDouble(sCoefVals[j]);
            }

        }
        return 1;

    }

    public String getCoefResult()
    {
        StringBuilder sb = new StringBuilder();
        // res = numFolds$feature set indices$fold1 ~ fold2 ~ fold3 ~ .. foldn
        // fold1 = coefval1, coefval2 , coefval3.. ,coefvaln

        for(int i = 0; i < featureIndices.length; i ++)
        {
            sb.append(featureIndices[i]);
            if(i != featureIndices.length - 1)
                sb.append(",");
        }
        sb.append("$");
        StringBuilder sbFolds = new StringBuilder();
        for(int i = 0; i < numFolds; i ++)
        {
            for(int j = 0; j < featureIndices.length; j ++)
            {
                sbFolds.append(coefficients[i][j]);
                if(j != featureIndices.length - 1)
                    sbFolds.append(",");
            }
            if(i != numFolds - 1)
                sbFolds.append("~");
        }
        sb.append(sbFolds.toString());
        return sb.toString();
    }

    public String getCVResult()
    {
        StringBuilder sb = new StringBuilder();
        // res = numFolds$feature set indices$fold1 ~ fold2 ~ fold3 ~ .. foldn
        // fold1 = cv1 ! cv2 ! cv3.. !cvn

        for(int i = 0; i < featureIndices.length; i ++)
        {
            sb.append(featureIndices[i]);
            if(i != featureIndices.length - 1)
                sb.append(",");
        }
        sb.append("$");
        StringBuilder sbFolds = new StringBuilder();
        for(int i = 0; i < numFolds; i ++)
        {
            double cv = numFailures[i]/numObservations[i];
            sbFolds.append(cv);
            if(i != numFolds - 1)
                sbFolds.append("~");
        }
        sb.append(sbFolds.toString());
        return sb.toString();
    }

}
